---
title: UI Tour
slug: Tools/Performance/UI_Tour
---
<div>{{ToolsSidebar}}</div><p>The performance tool's UI consists of 4 main pieces:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13220/perf-tool-pieces.png" style="display: block; height: 351px; margin-left: auto; margin-right: auto; width: 808px;"></p>

<ul>
 <li><a href="/en-US/docs/Tools/Performance/UI_Tour#Toolbar">Toolbar</a></li>
 <li><a href="/en-US/docs/Tools/Performance/UI_Tour#Recordings_pane">Recordings pane</a></li>
 <li><a href="/en-US/docs/Tools/Performance/UI_Tour#Recording_overview">Recording overview</a></li>
 <li><a href="/en-US/docs/Tools/Performance/UI_Tour#Details_pane">Details pane</a>, which may contain any one of:
  <ul>
   <li><a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a></li>
   <li><a href="/en-US/docs/Tools/Performance/Call_Tree">Call Tree</a></li>
   <li><a href="/en-US/docs/Tools/Performance/Flame_Chart">Flame Chart</a></li>
  </ul>
 </li>
</ul>

<h2 id="Toolbar">Toolbar</h2>

<p>The toolbar contains buttons to:</p>

<ul>
 <li>start and stop a recording</li>
 <li>import a recording you previously saved</li>
 <li>clear the Recordings pane. <em>Note that if you do this, you lose any recordings you have not saved.</em></li>
 <li>filter the <a href="/en-US/docs/Tools/Performance/Waterfall#Markers">markers</a> that are displayed in the Waterfall view</li>
 <li>switch the active tool in the <a href="/en-US/docs/Tools/Performance/UI_Tour#Details_pane">Details pane</a>.</li>
 <li>access the Settings popup</li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/13222/perf-toolbar.png" style="display: block; height: 434px; margin-left: auto; margin-right: auto; width: 836px;"></p>

<h2 id="Recordings_pane">Recordings pane</h2>

<p>The recordings pane lists all the recordings you have loaded, including any you have made in this session and any you have imported.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10917/perf-recordings-pane.png" style="display: block; height: 337px; margin-left: auto; margin-right: auto; width: 300px;"></p>

<p>At any given time, one recording is selected, and that recording is displayed in the rest of the tool. To select a different recording, click its entry in the pane. To save the recording as a JSON file click "Save".</p>

<h2 id="Recording_overview">Recording overview</h2>

<p>This displays an overview of the entire recording, with the x-axis representing time.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10919/perf-overview.png" style="display: block; height: 164px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<p>It contains two elements: an overview of the Waterfall and a frame rate graph.</p>

<h3 id="Waterfall_overview">Waterfall overview</h3>

<p>This presents a compressed view of the <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a>:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10923/perf-waterfall-overview.png" style="display: block; height: 76px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<p>Recorded operations are color-coded using <a href="/en-US/docs/Tools/Performance/Waterfall#Markers">the same scheme as in the main Waterfall view</a>.</p>

<h3 id="Frame_rate_graph">Frame rate graph</h3>

<p>The frame rate gives you an overview of the browser's responsiveness during the recording:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10921/perf-frame-rate.png" style="display: block; height: 88px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<p>See the separate article on <a href="/en-US/docs/Tools/Performance/Frame_rate">frame rate</a>.</p>

<h3 id="Correlating_events">Correlating events</h3>

<p>Because these elements are synchronized, you can correlate events in one element with events in another.</p>

<p>For example, in the screenshot below a long-running paint operation (<a href="/en-US/docs/Tools/Performance/Waterfall#Markers">shown as a green bar</a> in the waterfall overview) corresponds to a drop in the frame rate:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10925/perf-overview-correlation.png" style="display: block; height: 494px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<h3 id="Zooming_in">Zooming in</h3>

<p>You can use the overview to select a slice of the recording to examine in more detail. Select a slice, and the main view will be updated to contain just the part selected. In the screenshot below we've selected that drop in the frame rate, and can see the long-running paint operation in more detail:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10927/perf-zoomed.png" style="display: block; height: 416px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<h2 id="Details_pane">Details pane</h2>

<p>The Details pane shows whichever tool is currently selected. To switch to a different tool, use the buttons in the <a href="/en-US/docs/Tools/Performance/UI_Tour#Toolbar">Toolbar</a>.</p>

<h3 id="Waterfall">Waterfall</h3>

<p>The Waterfall presents a view of the work the browser is doing during the recording: executing JavaScript, updating the CSS, updating the page layout, and performing repaints. The x-axis represents time, and the recorded operations are laid out as a waterfall, reflecting the serial nature of the browser's execution.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10929/perf-waterfall.png" style="display: block; height: 568px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<p>To learn much more about the Waterfall, see the separate <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a> page.</p>

<h3 id="Call_Tree">Call Tree</h3>

<p>The Call Tree is a sampling profiler for JavaScript running in the page. It periodically samples the state of the JavaScript engine, and records the stack for the code executing at the time the sample was taken. Statistically, the number of samples taken in which we were executing a particular function corresponds to the amount of time the browser is spending executing it, so you can identify bottlenecks in your code.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10949/perf-call-tree.png" style="display: block; height: 384px; margin-left: auto; margin-right: auto; width: 972px;"><br>
 To learn much more about the Call Tree, see the separate <a href="/en-US/docs/Tools/Performance/Call_Tree">Call Tree</a> page.</p>

<h3 id="Flame_Chart">Flame Chart</h3>

<p>If the Call Tree tells you, statistically, which functions your site is spending most time executing across the whole recording, the Flame Chart tells you the call stack at any given point during the recording:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10933/perf-flame-chart.png" style="display: block; height: 504px; margin-left: auto; margin-right: auto; width: 972px;"></p>

<p>To learn much more about the Flame Chart, see the separate <a href="/en-US/docs/Tools/Performance/Flame_Chart">Flame Chart</a> page.</p>

<h3 id="Allocations">Allocations</h3>

<div class="geckoVersionNote">
<p>The Allocations view is new in Firefox 46.</p>
</div>

<p>The Allocations view is like the Call Tree view, but for allocations: it shows you which functions in your page are allocating the most memory over the course of the profile.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12413/allocations-view-1.png" style="display: block; margin-left: auto; margin-right: auto; width: 972px;"></p>

<p>The Allocations view only appears if you checked "Record Allocations" in the Performance tool settings, before recording a profile:</p>

<p>{{EmbedYouTube("Le9tTo7bqts")}}</p>

<p>To learn much more about the Allocations view, see the separate <a href="/en-US/docs/Tools/Performance/Allocations">Allocations</a> page.</p>

